#!/bin/sh
# 		People Converter 2.0 -- people.sh
# Bash Shell script for converting a text file containing comma-delimited
# fields - as exported from an Address Book - into BeOS People files.
# Inspired by Scot Hacker's script of the same name.
# Ensure that the address file is named 'people.txt' and that you have
# edited the 'fields' string below to match the content and structure of 
# your file.
#		-- Daniel Chin Yee 2000/4
#------------------------------------------------------------------
# ***IMPORTANT*** 	Edit the 'fields' string below. Consult the 
# 			'readme.first' file for instructions.

fields="group firstname lastname city email zip cphone hphone state wposition email2 address company fax wcity waddress2 url country waddress wstate"

#------------------------------------------------------------------
# determine the index of the 'name' field
nameindex=`echo "$fields" | gawk '{split ($0,flds," "); for \
		(fld in flds) if (flds[fld]=="lastname") print fld}' -`

echo -e "\nCreating People Files...."
# draw a line to use as a progress indicator
echo "`wc -l < people.txt` people to create"
while read ThisPerson; do echo -n "_"; done < people.txt
echo

# Now loop through the files in the 'results' directory.
# For each file, 'touch' a new file with the value of the name
# field as the file name. Convert this file to a people file.
# Assign the file name to 'newperson' variable for later use.

{
while read ThisPerson
do	name="`echo "$ThisPerson" | gawk -F, '{print $INDEX}' \
	INDEX=$nameindex -`"
	newperson="results/$name"
	touch "$newperson"
	addattr -t MIME BEOS:TYPE application/x-person "$newperson"

# Loop through the attributes in the 'fields' variable and
# assign people attributes for each one.

	for attr in $fields
	do	value="`echo "$ThisPerson" | gawk -F, \
		'{split (fields,flds," ");\
		for (fld in flds) if (flds[fld]==attr) print $fld}'\
		attr=$attr fields="$fields" -`"
		addattr META:$attr "$value" "$newperson"
	done
	echo -n "|"	# Update the progress indicator.
done
} < people.txt

echo -e "\a\nNow, if everything is in order, you may copy the files"
echo -e "to your 'People' folder\n"
